/// <reference types="react" />
import type { CardVariantProps } from "./components/CardVariant";
import type { CardProps as CardNormalProps } from "./components/Card";
declare namespace CardProps {
    type Normal = {
        type: "normal";
        cardProps: CardNormalProps;
    };
    type Variant = {
        type: "variant";
        cardProps: CardVariantProps;
    };
}
declare type CardProps = CardProps.Normal | CardProps.Variant;
export declare type CardSectionProps = {
    className?: string;
    title?: string;
    cards?: CardProps[];
    /**
     * specify the maximum screen width in witch the thumbnails
     * are displayed as columns.
     */
    breakpointForColumnDisplay?: number;
    showMoreMessage?: string;
};
export declare const CardSection: import("react").MemoExoticComponent<(props: CardSectionProps) => JSX.Element>;
export {};
