"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CardSection = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
/* eslint-disable @typescript-eslint/no-namespace */
var react_1 = require("react");
var CardVariant_1 = require("./components/CardVariant");
var Card_1 = require("./components/Card");
var onyxia_ui_1 = require("onyxia-ui");
var theme_1 = require("./theme");
var powerhooks_1 = require("powerhooks");
var getUseClassNames = function () {
    var createUseClassNames = theme_1.getThemeApi().createUseClassNames;
    var useClassNames = createUseClassNames()(function (theme, _a) {
        var _b, _c;
        var breakpointForColumnDisplay = _a.breakpointForColumnDisplay, title = _a.title;
        return ({
            "title": {
                "marginBottom": theme.spacing(7.5),
                "marginTop": theme.spacing(17.25),
                "display": "flex",
                "justifyContent": title ? "space-between" : "flex-end",
                "paddingLeft": theme.spacing(13),
                "paddingRight": theme.spacing(13),
                "& h3": {
                    "color": theme.colors.palette.orangeWarning.main,
                    "cursor": "pointer",
                },
            },
            "cards": (_b = {
                    "display": "flex",
                    "flexWrap": "wrap",
                    "justifyContent": "center"
                },
                _b[theme.breakpoints.down(breakpointForColumnDisplay !== undefined ? breakpointForColumnDisplay : "sm")] = {
                    "flexDirection": "column",
                    "alignItems": "center",
                    "paddingLeft": theme.spacing(4.5),
                    "paddingRight": theme.spacing(4.5),
                },
                _b),
            "card": (_c = {
                    "margin": theme.spacing(1.5)
                },
                _c[theme.breakpoints.down(breakpointForColumnDisplay !== undefined ? breakpointForColumnDisplay : "sm")] = {
                    "width": "100%",
                    "margin": [1.5, 0, 1.5, 0].map(function (spacing) { return theme.spacing(spacing) + "px"; }).join(" "),
                },
                _c),
        });
    }).useClassNames;
    return { useClassNames: useClassNames };
};
exports.CardSection = react_1.memo(function (props) {
    var title = props.title, cards = props.cards, className = props.className, breakpointForColumnDisplay = props.breakpointForColumnDisplay, showMoreMessage = props.showMoreMessage;
    var sectionRef = react_1.useRef(null);
    var _a = powerhooks_1.useNamedState("areExtraThumbNailsExposed", false), areExtraThumbNailsExposed = _a.areExtraThumbNailsExposed, setAreExtraThumbNailsExposed = _a.setAreExtraThumbNailsExposed;
    if (cards !== undefined) {
        console.log(cards[0].type);
        console.log(cards[0].cardProps);
    }
    var useClassNames = powerhooks_1.useGuaranteedMemo(function () { return getUseClassNames(); }, []).useClassNames;
    var classNames = useClassNames({ breakpointForColumnDisplay: breakpointForColumnDisplay, title: title }).classNames;
    var exposeHiddenThumbNails = powerhooks_1.useConstCallback(function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    setAreExtraThumbNailsExposed(!areExtraThumbNailsExposed);
                    if (areExtraThumbNailsExposed || !sectionRef.current) {
                        return [2 /*return*/];
                    }
                    return [4 /*yield*/, new Promise(function (resolve) { return setTimeout(resolve, 1); })];
                case 1:
                    _a.sent();
                    window.scrollTo({
                        "behavior": "smooth",
                        "top": window.scrollY + sectionRef.current.getBoundingClientRect().top,
                    });
                    return [2 /*return*/];
            }
        });
    }); });
    return (jsx_runtime_1.jsxs("section", __assign({ ref: sectionRef, className: className }, { children: [jsx_runtime_1.jsxs("div", __assign({ className: classNames.title }, { children: [title && jsx_runtime_1.jsx(onyxia_ui_1.Typography, __assign({ variant: "h2" }, { children: title }), void 0),
                    cards && cards.length > 4 && (jsx_runtime_1.jsxs(onyxia_ui_1.Typography, __assign({ onClick: exposeHiddenThumbNails, variant: "h3" }, { children: [showMoreMessage ? showMoreMessage : "Show More", " (", cards.length, ")"] }), void 0))] }), void 0),
            cards && (jsx_runtime_1.jsx("div", __assign({ className: classNames.cards }, { children: cards
                    .slice(0, cards.length < 4 || areExtraThumbNailsExposed ? cards.length : 4)
                    .map(function (card, index) {
                    if (card.type === "normal") {
                        return (jsx_runtime_1.jsx(Card_1.Card, __assign({ className: classNames.card }, card.cardProps), index));
                    }
                    return (jsx_runtime_1.jsx(CardVariant_1.CardVariant, __assign({ className: classNames.card }, card.cardProps), index));
                }) }), void 0))] }), void 0));
});
//# sourceMappingURL=CardSection.js.map