/// <reference types="react" />
import type { ImageProps } from "./components/Image";
import type { Props as CodeProps } from "./components/Code";
import type { CardSectionProps } from "./CardSection";
declare namespace IllustrationProps {
    type Code = {
        type: "code";
        codeProps: CodeProps;
    };
    type Image = {
        type: "image";
        imageProps: ImageProps;
    };
}
export declare type SectionProps = {
    className?: string;
    cardSection?: CardSectionProps;
    illustration?: IllustrationProps.Code | IllustrationProps.Image;
    title?: string;
    article?: {
        title: string;
        /**
         * you can use markdown between back ticks.
         */
        paragraphMd: string;
        button?: {
            className?: string;
            title: string;
            href: string;
        };
    };
    isRowReverse?: boolean;
};
export declare const Section: import("react").MemoExoticComponent<(props: SectionProps) => JSX.Element>;
export {};
