"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Section = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
/* eslint-disable @typescript-eslint/no-namespace */
var Typography_1 = require("onyxia-ui/Typography");
var react_markdown_1 = __importDefault(require("react-markdown"));
var Image_1 = require("./components/Image");
var react_1 = require("react");
var tss_react_1 = require("tss-react");
var Code_1 = require("./components/Code");
var Button_1 = require("./components/Button");
var theme_1 = require("./theme");
var powerhooks_1 = require("powerhooks");
var CardSection_1 = require("./CardSection");
var getUseClassNames = function () {
    var createUseClassNames = theme_1.getThemeApi().createUseClassNames;
    var useClassNames = createUseClassNames()(function (theme, _a) {
        var _b, _c, _d, _e, _f, _g;
        var isRowReverse = _a.isRowReverse;
        return ({
            "root": {
                "position": "relative",
                "marginTop": theme.spacing(17.25),
            },
            "smallThumbNails": {
                "display": "flex",
                "flexWrap": "wrap",
                "flexDirection": "row",
                "justifyContent": "center",
                "marginBottom": theme.spacing(17.25),
                "& >div": {
                    "margin": theme.spacing(1.5),
                },
            },
            "title": (_b = {
                    "fontSize": "40px",
                    "textAlign": "center",
                    "marginBottom": theme.spacing(7.5)
                },
                _b[theme.breakpoints.down("sm")] = {
                    "textAlign": "left",
                    "paddingLeft": theme.spacing(4.5),
                    "paddingRight": theme.spacing(4.5),
                },
                _b),
            "articleAndImageWrapper": (_c = {
                    "display": "flex",
                    "flexDirection": isRowReverse ? "row-reverse" : "row",
                    "justifyContent": "center",
                    "alignItems": "center",
                    "marginTop": theme.spacing(17.25),
                    "paddingLeft": theme.spacing(6),
                    "paddingRight": theme.spacing(6)
                },
                _c[theme.breakpoints.down("sm")] = {
                    "flexDirection": "column-reverse",
                    "paddingLeft": theme.spacing(4.5),
                    "paddingRight": theme.spacing(4.5),
                },
                _c),
            "article": (_d = {
                    "display": "flex",
                    "flexDirection": "column",
                    "width": 412,
                    "textAlign": "left"
                },
                _d[isRowReverse ? "marginLeft" : "marginRight"] = theme.spacing(16),
                _d[theme.breakpoints.down("md")] = (_e = {},
                    _e[isRowReverse ? "marginLeft" : "marginRight"] = theme.spacing(1.5),
                    _e["width"] = 302,
                    _e),
                _d["& h2"] = {
                    "marginBottom": 14,
                },
                _d["& p"] = {
                    "fontSize": theme.typography.body1.fontSize,
                    "lineHeight": "24px",
                    "marginTop": 14,
                    "marginBottom": 14,
                },
                _d[theme.breakpoints.down("sm")] = {
                    "width": "100%",
                    "margin": "unset",
                    "marginTop": theme.spacing(4),
                },
                _d),
            "illustration": (_f = {
                    "width": 900
                },
                _f[isRowReverse ? "marginRight" : "marginLeft"] = theme.spacing(16),
                _f[theme.breakpoints.down("md")] = (_g = {},
                    _g[isRowReverse ? "marginRight" : "marginLeft"] = theme.spacing(1.5),
                    _g["width"] = 464,
                    _g),
                _f[theme.breakpoints.down("sm")] = {
                    "margin": "unset",
                    "width": "100%",
                },
                _f),
            "button": {
                "color": "unset !important",
                "backgroundColor": "unset !important",
                "borderColor": "unset !important",
                "alignSelf": "right",
            },
        });
    }).useClassNames;
    return { useClassNames: useClassNames };
};
exports.Section = react_1.memo(function (props) {
    var _a, _b, _c, _d, _e, _f, _g;
    var article = props.article, illustration = props.illustration, isRowReverse = props.isRowReverse, className = props.className, cardSection = props.cardSection, title = props.title;
    var useClassNames = powerhooks_1.useGuaranteedMemo(function () { return getUseClassNames(); }, []).useClassNames;
    var classNames = useClassNames({
        isRowReverse: isRowReverse,
    }).classNames;
    return (jsx_runtime_1.jsxs("section", __assign({ className: tss_react_1.cx(classNames.root, className) }, { children: [title && (jsx_runtime_1.jsx(Typography_1.Typography, __assign({ className: classNames.title, variant: "h2" }, { children: title }), void 0)),
            jsx_runtime_1.jsx(CardSection_1.CardSection, __assign({}, cardSection), void 0),
            jsx_runtime_1.jsxs("article", __assign({ className: classNames.articleAndImageWrapper }, { children: [article && (jsx_runtime_1.jsxs("div", __assign({ className: classNames.article }, { children: [jsx_runtime_1.jsx(Typography_1.Typography, __assign({ variant: "h2" }, { children: article.title }), void 0),
                            jsx_runtime_1.jsx(react_markdown_1.default, { children: article.paragraphMd }, void 0),
                            article.button && (jsx_runtime_1.jsx("div", __assign({ className: tss_react_1.cx(tss_react_1.css({
                                    "display": "flex",
                                    "justifyContent": "flex-end",
                                    "marginTop": 14,
                                }), article.button.className) }, { children: jsx_runtime_1.jsx(Button_1.Button, __assign({ className: classNames.button, type: "submit", href: article.button.href }, { children: article.button.title }), void 0) }), void 0))] }), void 0)),
                    illustration &&
                        (illustration.type === "image" ? (jsx_runtime_1.jsx(Image_1.Image, { url: (_a = illustration.imageProps) === null || _a === void 0 ? void 0 : _a.url, alt: (_b = illustration.imageProps) === null || _b === void 0 ? void 0 : _b.alt, className: tss_react_1.cx(classNames.illustration, (_c = illustration.imageProps) === null || _c === void 0 ? void 0 : _c.className) }, void 0)) : (jsx_runtime_1.jsx(Code_1.Code, { text: (_d = illustration.codeProps) === null || _d === void 0 ? void 0 : _d.text, language: (_e = illustration.codeProps) === null || _e === void 0 ? void 0 : _e.language, showLineNumbers: (_f = illustration.codeProps) === null || _f === void 0 ? void 0 : _f.showLineNumbers, className: tss_react_1.cx(classNames.illustration, (_g = illustration.codeProps) === null || _g === void 0 ? void 0 : _g.className) }, void 0)))] }), void 0)] }), void 0));
});
//# sourceMappingURL=Section.js.map