/// <reference types="react" />
declare namespace BackgroundProps {
    type Image = {
        type: "image";
        url: string;
    };
    type Color = {
        type: "color";
        color: string;
    };
}
declare type BackgroundProps = BackgroundProps.Color | BackgroundProps.Image;
export declare type CardVariantProps = {
    background?: BackgroundProps;
    className?: string;
    footer?: {
        title?: string;
        subTitle?: string;
        height?: string | number;
    };
    button?: {
        title: string;
        href: string;
        color?: string;
        backgroundColor?: string;
    };
};
export declare const CardVariant: import("react").MemoExoticComponent<(props: CardVariantProps) => JSX.Element>;
export {};
