"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CardVariant = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
/* eslint-disable @typescript-eslint/no-namespace */
var react_1 = require("react");
var Typography_1 = require("onyxia-ui/Typography");
var tss_react_1 = require("tss-react");
var Button_1 = require("./Button");
var theme_1 = require("../theme");
var powerhooks_1 = require("powerhooks");
var getUseClassNames = function () {
    var createUseClassNames = theme_1.getThemeApi().createUseClassNames;
    var useClassNames = createUseClassNames()(function (theme, _a) {
        var background = _a.background, footer = _a.footer, button = _a.button;
        return ({
            "root": {
                "borderRadius": 16,
                "height": 563,
                "width": 412,
                "display": "flex",
                "flexDirection": "column",
                "justifyContent": "space-between",
                "overflow": "hidden",
            },
            "tagWithBackground": {
                "background": (function () {
                    if (background === undefined) {
                        return theme.isDarkModeEnabled
                            ? theme.colors.palette.dark.greyVariant3
                            : theme.colors.palette.light.greyVariant3;
                    }
                    if (background.type === "color") {
                        return background.color;
                    }
                    return "url(" + background.url + ") no-repeat center";
                })(),
            },
            "footer": {
                "height": (function () {
                    if (footer === undefined) {
                        return 161;
                    }
                    return footer.height;
                })(),
                "backgroundColor": theme.isDarkModeEnabled
                    ? theme.colors.palette.dark.greyVariant1
                    : theme.colors.palette.light.light,
                "paddingLeft": theme.spacing(3),
                "paddingRight": theme.spacing(3),
                "& h5": {
                    "marginTop": theme.spacing(2),
                    "marginBottom": theme.spacing(1.25),
                },
            },
            "header": {
                "flex": 1,
                "width": "100%",
                "margin": 0,
            },
            "buttonWrapper": {
                "display": "flex",
                "justifyContent": "flex-end",
                "& button": {
                    "alignSelf": "right",
                    "color": (button === null || button === void 0 ? void 0 : button.color) === undefined ? "unset !important" : button.color + " !important",
                    "borderColor": "unset !important",
                    "backgroundColor": (button === null || button === void 0 ? void 0 : button.backgroundColor) === undefined
                        ? "unset !important"
                        : button.backgroundColor + " !important",
                    "border": (button === null || button === void 0 ? void 0 : button.backgroundColor) === undefined ? undefined : "unset !important",
                },
                "paddingTop": theme.spacing(2),
                "paddingRight": theme.spacing(2),
            },
        });
    }).useClassNames;
    return { useClassNames: useClassNames };
};
exports.CardVariant = react_1.memo(function (props) {
    var className = props.className, background = props.background, button = props.button, footer = props.footer;
    var useClassNames = powerhooks_1.useGuaranteedMemo(function () { return getUseClassNames(); }, []).useClassNames;
    var classNames = useClassNames({
        background: background,
        button: button,
        footer: footer,
    }).classNames;
    return (jsx_runtime_1.jsxs("div", __assign({ className: tss_react_1.cx(classNames.root, className) }, { children: [jsx_runtime_1.jsx("div", __assign({ className: tss_react_1.cx(classNames.tagWithBackground, classNames.header) }, { children: jsx_runtime_1.jsx("div", __assign({ className: classNames.buttonWrapper }, { children: button && jsx_runtime_1.jsx(Button_1.Button, __assign({ href: button.href }, { children: button.title }), void 0) }), void 0) }), void 0),
            footer && (jsx_runtime_1.jsxs("div", __assign({ className: classNames.footer }, { children: [footer.title && jsx_runtime_1.jsx(Typography_1.Typography, __assign({ variant: "h5" }, { children: footer.title }), void 0),
                    footer.subTitle && jsx_runtime_1.jsx(Typography_1.Typography, __assign({ variant: "subtitle1" }, { children: footer.subTitle }), void 0)] }), void 0))] }), void 0));
});
//# sourceMappingURL=CardVariant.js.map