"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TopBar = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
/* eslint-disable @typescript-eslint/no-namespace */
/* eslint-disable @typescript-eslint/no-explicit-any */
var List_1 = __importDefault(require("@material-ui/core/List"));
var Link_1 = __importDefault(require("@material-ui/core/Link"));
var useNamedState_1 = require("powerhooks/useNamedState");
var useConstCallback_1 = require("powerhooks/useConstCallback");
var tss_react_1 = require("tss-react");
var useClickAway_1 = require("powerhooks/useClickAway");
var react_1 = require("react");
var Logo_1 = require("./Logo");
var react_markdown_1 = __importDefault(require("react-markdown"));
var Typography_1 = require("onyxia-ui/Typography");
var theme_1 = require("../theme");
var theme_2 = require("../theme");
var powerhooks_1 = require("powerhooks");
var getUseClassNames = function () {
    var createUseClassNames = theme_2.getThemeApi().createUseClassNames;
    var useClassNames = createUseClassNames()(function (theme, _a) {
        var _b, _c, _d, _e;
        var mobileMenuHeight = _a.mobileMenuHeight;
        return ({
            "root": (_b = {
                    "display": "flex",
                    "justifyContent": "flex-end",
                    "flexWrap": "wrap",
                    "alignItems": "center",
                    "width": "100%",
                    "padding": [4.5, 12.5, 4.5, 12.5].map(function (spacing) { return theme.spacing(spacing) + "px"; }).join(" ")
                },
                _b[theme.breakpoints.down("md")] = {
                    "padding": [2, 4.5, 2, 4.5].map(function (spacing) { return theme.spacing(spacing) + "px"; }).join(" "),
                },
                _b),
            "title": {
                "display": "flex",
                "alignItems": "center",
                "marginRight": "auto",
                "& svg": {
                    "height": 50,
                    "width": 50,
                },
            },
            "itemWrapper": (_c = {},
                _c[theme.breakpoints.down("md")] = {
                    "transition": "height 400ms",
                    "order": 3,
                    "flex": "1 0 100%",
                    "textAlign": "left",
                    "height": mobileMenuHeight,
                    "overflow": "hidden",
                    "display": "flex",
                    "flexDirection": "column",
                },
                _c),
            "link": (_d = {
                    "color": theme.isDarkModeEnabled ? "white" : "black",
                    "fontSize": "22px",
                    "lineHeight": "32px",
                    "marginLeft": theme.spacing(8)
                },
                _d[theme.breakpoints.down("md")] = {
                    "margin": "5px 0 5px 0",
                },
                _d),
            "unfold": (_e = {
                    "order": 2,
                    "marginLeft": 10,
                    "display": "none",
                    "cursor": "pointer"
                },
                _e[theme.breakpoints.down("md")] = {
                    "display": "flex",
                    "alignItems": "center",
                },
                _e),
        });
    }).useClassNames;
    return { useClassNames: useClassNames };
};
function TopBar(props) {
    var menuItems = props.menuItems, title = props.title, className = props.className;
    var _a = useNamedState_1.useNamedState("mobileMenuHeight", 0), mobileMenuHeight = _a.mobileMenuHeight, setMobileMenuHeight = _a.setMobileMenuHeight;
    var rootRef = useClickAway_1.useClickAway(function () { return setMobileMenuHeight(0); }).rootRef;
    var titleRef = react_1.useRef(null);
    var menuRef = react_1.useRef(null);
    var toggleMobileMenu = useConstCallback_1.useConstCallback(function () {
        if (mobileMenuHeight !== 0) {
            setMobileMenuHeight(0);
            return;
        }
        var menuItems = document.getElementsByClassName("menu-item");
        var newHeight = (parseInt(getComputedStyle(menuItems[0]).marginTop.replace("px", "")) +
            parseInt(getComputedStyle(menuItems[0]).marginBottom.replace("px", "")) +
            menuItems[0].clientHeight) *
            menuItems.length;
        setMobileMenuHeight(newHeight);
    });
    var useClassNames = powerhooks_1.useGuaranteedMemo(function () { return getUseClassNames(); }, []).useClassNames;
    var classNames = useClassNames({
        mobileMenuHeight: mobileMenuHeight,
    }).classNames;
    return (jsx_runtime_1.jsxs(List_1.default, __assign({ className: tss_react_1.cx(classNames.root, className), component: "nav" }, { children: [jsx_runtime_1.jsx("div", __assign({ ref: titleRef, className: classNames.title }, { children: (function () {
                    if (title === undefined) {
                        return;
                    }
                    if (title.type === "logo") {
                        return jsx_runtime_1.jsx(Logo_1.Logo, { logoUrl: title.logoUrl }, void 0);
                    }
                    return (jsx_runtime_1.jsx(Typography_1.Typography, __assign({ variant: "h3" }, { children: jsx_runtime_1.jsx(react_markdown_1.default, { children: title.markdown }, void 0) }), void 0));
                })() }), void 0),
            jsx_runtime_1.jsx("div", __assign({ ref: menuRef, className: classNames.itemWrapper }, { children: menuItems !== undefined &&
                    menuItems.map(function (item) { return (jsx_runtime_1.jsx(Link_1.default, __assign({ className: tss_react_1.cx(classNames.link, "menu-item"), href: item.url }, { children: item.name }), JSON.stringify(item.name + item.url))); }) }), void 0),
            jsx_runtime_1.jsx("div", __assign({ ref: rootRef, className: classNames.unfold }, { children: jsx_runtime_1.jsx(theme_1.Icon, { id: "dehaze", onClick: toggleMobileMenu }, void 0) }), void 0)] }), void 0));
}
exports.TopBar = TopBar;
//# sourceMappingURL=TopBar.js.map