/// <reference types="react" />
import "onyxia-ui/assets/fonts/work-sans.css";
import type { ThemeProviderProps, Theme } from "onyxia-ui";
export declare function overwriteTheme(params: {
    ThemeProvider(props: ThemeProviderProps): JSX.Element;
    useTheme(): Theme;
}): void;
export declare function getThemeApi(): {
    ThemeProvider: (props: ThemeProviderProps) => JSX.Element;
    useTheme: () => Theme<{
        focus: {
            main: string;
            light: string;
            light2: string;
        };
        dark: {
            main: string;
            light: string;
            greyVariant1: string;
            greyVariant2: string;
            greyVariant3: string;
            greyVariant4: string;
        };
        light: {
            main: string;
            light: string;
            greyVariant1: string;
            greyVariant2: string;
            greyVariant3: string;
            greyVariant4: string;
        };
        redError: {
            main: string;
            light: string;
        };
        greenSuccess: {
            main: string;
            light: string;
        };
        orangeWarning: {
            main: string;
            light: string;
        };
        blueInfo: {
            main: string;
            light: string;
        };
    }, {
        typography: {
            textPrimary: string;
            textSecondary: string;
            textTertiary: string;
            textDisabled: string;
            textFocus: string;
        };
        buttons: {
            actionHoverPrimary: string;
            actionHoverSecondary: string;
            actionHoverTernary: string;
            actionSelected: string;
            actionActive: string;
            actionDisabled: string;
            actionDisabledBackground: string;
        };
        surfaces: {
            background: string;
            surface1: string;
            surface2: string;
        };
        alertSeverity: {
            error: {
                main: string;
                background: string;
            };
            success: {
                main: string;
                background: string;
            };
            warning: {
                main: string;
                background: string;
            };
            info: {
                main: string;
                background: string;
            };
        };
    }, {
        fontFamily: string;
        h1: {
            fontWeight: import("onyxia-ui/lib/typography").FontWeightProperty;
            fontSize: string;
            lineHeight: number;
        };
        h2: {
            fontWeight: import("onyxia-ui/lib/typography").FontWeightProperty;
            fontSize: string;
            lineHeight: number;
        };
        h3: {
            fontWeight: import("onyxia-ui/lib/typography").FontWeightProperty;
            fontSize: string;
            lineHeight: number;
        };
        h4: {
            fontWeight: import("onyxia-ui/lib/typography").FontWeightProperty;
            fontSize: string;
            lineHeight: number;
        };
        h5: {
            fontWeight: import("onyxia-ui/lib/typography").FontWeightProperty;
            fontSize: string;
            lineHeight: number;
        };
        h6: {
            fontWeight: import("onyxia-ui/lib/typography").FontWeightProperty;
            fontSize: string;
            lineHeight: number;
        };
        subtitle1: {
            fontWeight: import("onyxia-ui/lib/typography").FontWeightProperty;
            fontSize: string;
            lineHeight: number;
        };
        subtitle2: {
            fontWeight: import("onyxia-ui/lib/typography").FontWeightProperty;
            fontSize: string;
            lineHeight: number;
        };
        body1: {
            fontWeight: import("onyxia-ui/lib/typography").FontWeightProperty;
            fontSize: string;
            lineHeight: number;
        };
        body2: {
            fontWeight: import("onyxia-ui/lib/typography").FontWeightProperty;
            fontSize: string;
            lineHeight: number;
        };
        button: {
            fontWeight: import("onyxia-ui/lib/typography").FontWeightProperty;
            fontSize: string;
            lineHeight: number;
        };
        caption: {
            fontWeight: import("onyxia-ui/lib/typography").FontWeightProperty;
            fontSize: string;
            lineHeight: number;
        };
    }, Record<string, unknown>>;
    createUseClassNames: <Params extends Record<string, unknown> = {}>() => <Key extends string>(getCssObjects: (theme: Theme<{
        focus: {
            main: string;
            light: string;
            light2: string;
        };
        dark: {
            main: string;
            light: string;
            greyVariant1: string;
            greyVariant2: string;
            greyVariant3: string;
            greyVariant4: string;
        };
        light: {
            main: string;
            light: string;
            greyVariant1: string;
            greyVariant2: string;
            greyVariant3: string;
            greyVariant4: string;
        };
        redError: {
            main: string;
            light: string;
        };
        greenSuccess: {
            main: string;
            light: string;
        };
        orangeWarning: {
            main: string;
            light: string;
        };
        blueInfo: {
            main: string;
            light: string;
        };
    }, {
        typography: {
            textPrimary: string;
            textSecondary: string;
            textTertiary: string;
            textDisabled: string;
            textFocus: string;
        };
        buttons: {
            actionHoverPrimary: string;
            actionHoverSecondary: string;
            actionHoverTernary: string;
            actionSelected: string;
            actionActive: string;
            actionDisabled: string;
            actionDisabledBackground: string;
        };
        surfaces: {
            background: string;
            surface1: string;
            surface2: string;
        };
        alertSeverity: {
            error: {
                main: string;
                background: string;
            };
            success: {
                main: string;
                background: string;
            };
            warning: {
                main: string;
                background: string;
            };
            info: {
                main: string;
                background: string;
            };
        };
    }, {
        fontFamily: string;
        h1: {
            fontWeight: import("onyxia-ui/lib/typography").FontWeightProperty;
            fontSize: string;
            lineHeight: number;
        };
        h2: {
            fontWeight: import("onyxia-ui/lib/typography").FontWeightProperty;
            fontSize: string;
            lineHeight: number;
        };
        h3: {
            fontWeight: import("onyxia-ui/lib/typography").FontWeightProperty;
            fontSize: string;
            lineHeight: number;
        };
        h4: {
            fontWeight: import("onyxia-ui/lib/typography").FontWeightProperty;
            fontSize: string;
            lineHeight: number;
        };
        h5: {
            fontWeight: import("onyxia-ui/lib/typography").FontWeightProperty;
            fontSize: string;
            lineHeight: number;
        };
        h6: {
            fontWeight: import("onyxia-ui/lib/typography").FontWeightProperty;
            fontSize: string;
            lineHeight: number;
        };
        subtitle1: {
            fontWeight: import("onyxia-ui/lib/typography").FontWeightProperty;
            fontSize: string;
            lineHeight: number;
        };
        subtitle2: {
            fontWeight: import("onyxia-ui/lib/typography").FontWeightProperty;
            fontSize: string;
            lineHeight: number;
        };
        body1: {
            fontWeight: import("onyxia-ui/lib/typography").FontWeightProperty;
            fontSize: string;
            lineHeight: number;
        };
        body2: {
            fontWeight: import("onyxia-ui/lib/typography").FontWeightProperty;
            fontSize: string;
            lineHeight: number;
        };
        button: {
            fontWeight: import("onyxia-ui/lib/typography").FontWeightProperty;
            fontSize: string;
            lineHeight: number;
        };
        caption: {
            fontWeight: import("onyxia-ui/lib/typography").FontWeightProperty;
            fontSize: string;
            lineHeight: number;
        };
    }, Record<string, unknown>>, params: Params) => Record<Key, import("@emotion/serialize").CSSObject>) => {
        useClassNames: (params: Params) => {
            classNames: Record<Key, string>;
        };
    };
};
export declare const Icon: import("react").MemoExoticComponent<import("react").ForwardRefExoticComponent<import("onyxia-ui").IconProps<"iconButton" | "brightness4" | "brightness7" | "arrowBackIos" | "arrowForwardIos" | "dehaze" | "brightness1Rounded"> & import("react").RefAttributes<SVGSVGElement>>>;
export declare const IconButton: import("react").MemoExoticComponent<import("react").ForwardRefExoticComponent<import("onyxia-ui").IconButtonProps<"iconButton" | "brightness4" | "brightness7" | "arrowBackIos" | "arrowForwardIos" | "dehaze" | "brightness1Rounded"> & import("react").RefAttributes<HTMLButtonElement>>>;
export declare const Button: import("react").MemoExoticComponent<import("react").ForwardRefExoticComponent<import("onyxia-ui").ButtonProps<"iconButton" | "brightness4" | "brightness7" | "arrowBackIos" | "arrowForwardIos" | "dehaze" | "brightness1Rounded"> & import("react").RefAttributes<HTMLButtonElement>>>;
